#!/usr/bin/perl
# Purpose:
#   convert a GNOME .desktop file to a KDE .kdelnk file, and convert the
#   icon to XPM

$name=$ENV{'HOME'};
$GNOMENAME=@ARGV[0];
$KDENAME=$GNOMENAME;
$KDENAME =~ s|.desktop|.kdelnk|;
$KDENAME =~ s|/usr/share/gnome/apps/|$name/.kde/share/applnk/|;

if ( ! -d "$name/.kde/share/applnk" ) {
	system "mkdir -p ~/.kde/share/applnk";
}

if ( ! -d "$name/.kde/share/icons" ) {
	system "mkdir -p ~/.kde/share/icons";
}

if ( -d $GNOMENAME ) { # directory...
  if ( ! -d $KDENAME) {
    mkdir $KDENAME,0755;
  }
  exit;
}
if ( -e $KDENAME ) {
  exit;
}

open GNOME, $GNOMENAME || die "Can't open $GNOMENAME";
open KDE, ">$KDENAME" || die "Can't open $KDENAME for writing";

print KDE "# KDE Config File\n";
while(<GNOME>) {
  @line = split;
  if ($_ eq "[Desktop Entry]\n") {
    print KDE "[KDE Desktop Entry]\n";
  } else {
    if (substr($_,0,5) eq "Icon=") {
      $ICONNAME=substr($_,5,length($_)-6);
      $GNOMEICON="/usr/share/pixmaps/$ICONNAME";
      $EXTENSION=$ICONNAME;
      for($i=0;$i<length($EXTENSION);$i++) {
        $EXTENSION =~ s|.*\.||;
      }
      $ICONNAME=substr($ICONNAME,0,length($ICONNAME)-length($EXTENSION)-1);
      $KDEICON="$name/.kde/share/icons/$ICONNAME.xpm";
		print "$GNOMEICON\n";
		print "$KDENAME\n";
      $CONVCMD="convert $GNOMEICON XPM:$KDEICON";
      system "$CONVCMD";
      print KDE "Icon=$ICONNAME.xpm\n";
    } else {
      print KDE "$_";
    }
  }
};
close GNOME;
close KDE;
